﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace fejvagyiras
{
    class Program
    {
        static Random rnd = new Random();

        enum Sor { alap, szimpla, dupla, sok };

        static void Main(string[] args)
        {
            //Pénzfeldobás szimulálása
            Console.WriteLine("1. feladat");
            Console.WriteLine("A pénzfeldobás eredménye: {0}", Randobas());

            //Egy dobás kiértékelése
            Console.WriteLine("2. feladat");
            Console.Write("Tippeljen (F/I): ");
            string tipp = Console.ReadLine();
            char dob = Randobas();
            Console.WriteLine("A tipp {0}, a dobás eredménye {1} volt.\n{2}", tipp[0], dob, tipp[0] == dob ? "Ön eltalálta." : "Ön nem találta el.");

            //Adatfeldolgozás
            int db = 0;     //3. feladat: dobások száma
            int dbF = 0;    //4. feladathoz Fejek száma
                            //5. feladathoz FF állapota
            Sor fejek = Sor.alap;
            int dbDupla = 0;
            //6. feladathoz ma
            int dbMaxFsor = 0;
            int helyMaxFsor = 0;
            int dbAktFsor = 0;
            int helyAktFsor = 0;

            char eset;
            StreamReader sr = new StreamReader("kiserlet.txt");

            //kisérlet kiértékelése
            while (!sr.EndOfStream)
            {
                eset = sr.ReadLine()[0];
                //3. feladat: dobások száma
                db++;   //1-től számozott beolvasás

                if (eset == 'F')
                {
                    dbF++; //4. feladat
                    switch (fejek)  //5. feladat
                    {
                        //Visual Studio 2015-ben eddig beírva az enum alapján generálja az összes esetet :-)
                        case Sor.alap:
                            fejek = Sor.szimpla;
                            helyAktFsor = db;
                            break;
                        case Sor.szimpla:
                            fejek = Sor.dupla;
                            break;
                        case Sor.dupla:
                            fejek = Sor.sok;
                            break;
                        case Sor.sok:
                            break;
                    }
                    dbAktFsor++;    //6. feladat
                }
                else if (eset == 'I')
                {
                    if (fejek == Sor.dupla) //5. feladat (FF utáni I)
                    {
                        dbDupla++;
                    }
                    if (fejek != Sor.alap) //6. feladat (valahány F utáni első I)
                    {
                        if (dbAktFsor > dbMaxFsor)
                        {
                            dbMaxFsor = dbAktFsor;
                            helyMaxFsor = helyAktFsor;
                        }
                        dbAktFsor = 0;
                    }
                    fejek = Sor.alap;
                }
                else //bármilyen más adatszemét
                {
                    //eldobjuk
                }
            }
            sr.Close();

            //utolsó F-sorozatok kezelése - fájlvég mintha I lenne
            if (fejek == Sor.dupla)
            {
                dbDupla++;
            }
            if (dbAktFsor > dbMaxFsor)
            {
                dbMaxFsor = dbAktFsor;
                helyMaxFsor = helyAktFsor;
            }

            //3-6. feladatok eredményének kiírása
            Console.WriteLine("3. feladat");
            Console.WriteLine("A kísérlet {0} dobásból állt.", db);
            Console.WriteLine("4. feladat");
            Console.WriteLine("A kísérlet során a fej relatív gyakorisága {0:P2} volt.", dbF * 1.0 / db);
            Console.WriteLine("5. feladat");
            Console.WriteLine("A kísérlet során pontosan {0} alkalommal dobtak két fejet egymás után.", dbDupla);
            Console.WriteLine("6. feladat");
            Console.WriteLine("A leghosszabb tiszta fej sorozat {0} tagból áll, kezdete a(z) {1}. dobás.", dbMaxFsor, helyMaxFsor);

            //7. feladat FFFF és FFFI száma 1000 sorozatban
            Console.WriteLine("7. feladat");

            string teszt = "";  //helyette lehetne temp.txt
            int FFFF = 0;
            int FFFI = 0;
            for (int i = 0; i < 1000; i++)
            {
                Sor kezdet = Sor.alap;
                for (int j = 0; j < 3; j++)
                {
                    dob = Randobas();
                    teszt += dob;
                    if (dob == 'F')
                    {
                        kezdet++;
                    }              
                }
                dob = Randobas();
                teszt += dob;
                if (kezdet == Sor.sok)
                {
                    if (dob == 'F')
                    {
                        FFFF++;
                    }
                    else
                    {
                        FFFI++;
                    }
                }
                teszt += " ";
            }
            StreamWriter sw = new StreamWriter("dobasok.txt");
            sw.WriteLine("FFFF: {0}, FFFI: {1}", FFFF, FFFI);
            sw.WriteLine(teszt);
            sw.Close();
            Console.WriteLine("Fájlbaírás kész");
            Console.ReadLine();
        }

        private static char Randobas()
        {
            char e = 'I';
            if (rnd.NextDouble() < 0.5)
            {
                e = 'F';
            }
            return e;
        }
    }
}
